︠bf4f9ce3-f9bb-44c0-9053-afabb8c02592s︠
%load modular_symbol_map.pyx
︡edb60f82-9861-415a-abb4-7057441ddf7a︡{"done":true}︡
︠6bb2037c-9bfc-40ed-b1a1-86e8cc021bb2s︠
sage_server.MAX_OUTPUT = 1000000
for mf in ["431a", "431b", "433a"]:
    fp=open(mf,"w")
    M =  EllipticCurve(mf+"1").modular_symbol_space(sign=1)
    MSinfz = M.rational_period_mapping()([oo,0])[0]
    d = M.dimension()
    assert d == 1
    f = ModularSymbolMap(M)
    X,MSden = f.C._clear_denom()
    X=[a[0] for a in X]
    N = M.level()
    P1 = f.P1
    MStab = [[X[P1.index(a,b)] for b in Integers(N)] for a in Integers(N)]
    fp.write("int MStab_%s[] = {\n"%mf)
    for i in range(N):
        fp.write("%d,"%MStab[i][0])
        for j in range(1,N):
            fp.write("%d,"%MStab[i][j])
        fp.write("\n")
    fp.write("};\n\n")
    fp.write("int MSden_%s = %d;\n"%(mf,MSden))
    fp.write("int MSinfz_%s = %d;\n"%(mf,MSinfz))
    fp.write("\n")
    fp.close()
︡db1b8d82-4efa-4729-994f-8b1303503960︡{"done":true}︡
︠62238045-cedd-4a8b-a927-e2d2b3ac32cf︠
def contfrac_q(a, b):
    """
    Given coprime integers `a`, `b`, compute the sequence `q_i` of
    denominators in the continued fraction expansion of `a/b`
    """
    qi = [1]
    if a == 0:
        return qi
    if b == 0:
        raise ZeroDivisionError

    # one iteration isn't needed, since we are only computing the q_i.
    a,b = b, a%b
    i=1
    while b:
        if i >= 2:
            qi.append(qi[-1]*(a//b) + qi[-2])
        else:
            qi.append(a//b)
        a,b = b, a%b
        i += 1
    return qi


def eval(a,b,tab):
    q = contfrac_q(a,b)
    v = 0
    sign = 1
    for i in range(1,len(q)):
        v += tab[(sign*q[i])%N][q[i-1]%N]
        sign *= -1
    return v

def alphas(m,d,N,tab):
    assert is_prime(m) and d%2 == 1
    R = Integers(m)
    Npow = R(N)^((d-1)//2)
    gen = R(primitive_root(m))
    n = (m-1)//d
    b = gen
    h = gen^d
    return [sum([eval((Npow*b^i*h^j).lift(),m,tab) for j in range(n)]) for i in range(1,(d-1)//2+1)]

def normalize_alphas(alist,m,MSden,MSinfz):
    # should be normalized sqrt(euler-phi(m)/d * C_E + D_E), but computing C_E and D_E is a pain, and d is fixed
    return [(a/MSden+((m-1)//d)*MSinfz)/float(sqrt((m-1)*log(m))) for a in alist]

MOMENTS=10

def moments(alist):
    M=[0.0 for i in range(MOMENTS+1)]
    for a in alist:
        apow = 1.0
        for i in range(MOMENTS+1):
            M[i]+=apow
            apow *= a
    return [M[i]/len(alist) for i in range(MOMENTS+1)]

︡66bd3d59-849c-4ae5-af50-9b4839db192f︡{"done":true}︡
︠4d45c9d3-9ff1-4c93-9b16-7318ada32e8ds︠
d = 3
ms = [m for m in prime_range(3,100) if gcd(m,N)==1 and m % d == 1]
a = []
for m in ms:
    alist = alphas(m,d,N,MStab)
    print m, alist, normalize_alphas(alist,m,MSden,MSinfz)
    a += normalize_alphas(alist,m,MSden,MSinfz)
print len(a), moments(a)

︡fefd0b92-dc95-40df-969f-718628873789︡{"stdout":"7 [10] [2.0486181837244093]\n13 [-40] [-2.8839648458376375]\n19 [20] [2.197771062856737]\n31 [0] [0.9852354646140221]\n37 [-90] [-2.8943688907286744]\n43 [-50] [-0.87519498326369]\n61 [0] [1.2734658255021074]\n67 [0] [1.3206373835571303]\n73 [-30] [0.5120641372641447]\n79 [-10] [1.1375191405871572]\n97 [-170] [-2.5290558632256266]\n"}︡{"stdout":"11 [1.00000000000000, 0.0266115104590982, 3.52512683066233, -3.53963545770662, 20.9232254851203, -37.1832518540298, 147.698802179072, -328.021994193367, 1114.46611503492, -2766.60791251367, 8702.78902798087]\n"}︡{"done":true}︡
︠305d1f6f-7c73-4248-a138-7f93547122b5s︠
%time
load("compute_lambda.sage")
a=compute_dist(EllipticCurve("11a1"),2001,10000)
plot_histogram(a)
print ""
print "%d:"%len(a),
M = moments(a)
for i in range(1,MOMENTS+1):
    print "%.6f "%M[i],

︡6b5d066c-a81a-482d-9c62-dc5074258f60︡{"stdout":"2 1\nThere are 1 primes to use up to 10000\nStarting...\nX"}︡{"file":{"filename":"7d38178b-ef7c-4760-bf43-dbe14f0234ff.svg","show":true,"text":null,"uuid":"c4ebde1b-e109-43b1-a829-473068545e34"},"once":false}︡{"stdout":" \n"}︡{"stdout":"1000:"}︡{"stdout":" -0.000137  0.010476  -0.000002  0.000332  0.000001  0.000016  0.000000  0.000001  0.000000  0.000000 "}︡{"stdout":" \nCPU time: 0.25 s, Wall time: 0.26 s\n"}︡{"done":true}︡
︠5e6554ad-878f-4adb-b4da-386dfb4d81cfs︠
capture?

︡c999516b-5ade-47c0-a47e-cc82b7500cb6︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /projects/sage/sage-7.5/local/lib/python2.7/site-packages/smc_sagews/sage_salvus.py\nSignature : capture(self, code=None, stdout=None, stderr=None, append=False, echo=False)\nDocstring :\nCapture or ignore the output from evaluating the given code.\n(SALVUS only).\n\nUse capture as a block decorator by placing either %capture or\n%capture(optional args) at the beginning of a cell or at the\nbeginning of a line.  If you use just plain %capture then stdout\nand stderr are completely ignored.  If you use %capture(args) you\ncan redirect or echo stdout and stderr to variables or files.  For\nexample if you start a cell with this line:\n\n   %capture(stdout='output', stderr=open('error','w'), append=True, echo=True)\n\nthen stdout is appended (because append=True) to the global\nvariable output, stderr is written to the file 'error', and the\noutput is still displayed in the output portion of the cell\n(echo=True).\n\nINPUT:\n\n* stdout -- string (or object with write method) to send stdout\n  output to (string=name of variable)\n\n* stderr -- string (or object with write method) to send stderr\n  output to (string=name of variable)\n\n* append -- (default: False) if stdout/stderr are a string,\n  append to corresponding variable\n\n* echo   -- (default: False) if True, also echo stdout/stderr to\n  the output cell."}}︡{"done":true}︡
︠ce4d923b-d004-4496-aa5f-cedead691b7e︠

︡5f5fc8ef-97fb-45eb-a369-21801e57e5c4︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /projects/sage/sage-7.5/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\nDocstring :\nCell execution state object and wrapper for access to special\nSageMathCloud functionality.\n\nAn instance of this object is created each time you execute a cell.\nIt has various methods for sending different types of output\nmessages, links to files, etc.   Type 'help(smc)' for more details.\n\nOUTPUT LIMITATIONS -- There is an absolute limit on the number of\nmessages output for a given cell, and also the size of the output\nmessage for each cell.  You can access or change those limits\ndynamically in a worksheet as follows by viewing or changing any of\nthe following variables:\n\n   sage_server.MAX_STDOUT_SIZE       # max length of each stdout output message\n   sage_server.MAX_STDERR_SIZE       # max length of each stderr output message\n   sage_server.MAX_MD_SIZE           # max length of each md (markdown) output message\n   sage_server.MAX_HTML_SIZE         # max length of each html output message\n   sage_server.MAX_TEX_SIZE          # max length of tex output message\n   sage_server.MAX_OUTPUT_MESSAGES   # max number of messages output for a cell.\n\nAnd:\n\n   sage_server.MAX_OUTPUT            # max total character output for a single cell; computation\n                                     # terminated/truncated if sum of above exceeds this."}}︡{"done":true}︡
︠134067d7-6001-4a41-87cc-2d225a7cf658s︠
"%s/431a.txt"%os.environ['HOME']
︡a773ffa6-f3a2-4363-8b66-98cb19ad17cd︡{"stdout":"'/projects/68c8b2b8-03ba-44d4-a0d1-5d771c8cb465/431a.txt'\n"}︡{"done":true}︡
︠8d484918-edc4-4d69-8202-c2ed6e8145f2s︠
fp=open("foo.txt","w")
fp.write("hi")
fp.close()
︡cc4180be-25af-4fda-a263-78515ffbe54f︡{"done":true}︡
︠ed030817-bfde-4c46-bf3e-a4d8ba390654︠
︠d47c1e60-002b-477f-b5c9-42a39c7b7711︠









